#!/bin/bash
#
# Copyright (c) 2014, Intel Corporation
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#    * Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#    * Neither the name of Intel Corporation nor the names of its contributors
#      may be used to endorse or promote products derived from this software
#      without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# login as 'stack' and go to home directory
cd /home/stack/

# clone Devstack source
git clone https://github.com/openstack-dev/devstack.git
sleep 1
echo -e "done download devstack \n"

# use specific commit number and apply ovdk patches
cd /home/stack/devstack
git checkout d6f700db33aeab68916156a98971aef8cfa53a2e
sleep 1

patch -p1 < /home/stack/patches/devstack.patch
sleep 1
echo -e "done patch devstack \n"


# Devstack uses stable juno code, but still use proposed juno in config file 
# fix propsed/juno to stable/juno in stackrc file -appears that  this has been fixed be devstack now
#sed -i 's/proposed/stable/g' /home/stack/devstack/stackrc
#sleep 1


# clone Nova and Neutron source and apply ovdk patches
sudo mkdir /opt/stack
sudo chown stack:stack /opt/stack
sleep 1
echo -e "done creating /opt/stack/ \n"

# download nova
cd /opt/stack
git clone https://github.com/openstack/nova.git
sleep 1
echo -e "done download devstack nova  \n"

# patch Nova 
cd /opt/stack/nova
git checkout b7738bfb6c2f271d047e8f20c0b74ef647367111
patch -p1  < /home/stack/patches/nova.patch
sleep 1

# download neutron source and patch 
# this is not required now, but leave code here for potential future use
#git clone https://github.com/openstack/neutron.git
#sleep 1

#echo -e "done download devstack neutron  \n"
# patch Neutron - no need to patch neutron  


# make a copy of local.conf to /home/stack/devstack
cp /home/stack/local.conf /home/stack/devstack/local.conf
sleep 1

# run stack.sk to install Devstack
echo -e "start installing devstack - will take 8-10 minutes \n"
sleep 5
cd /home/stack/devstack/
./stack.sh

echo -e "done installing devstack \n"
sleep 1

# determine this is a controller node or a compute
node_type=`grep node "local.conf" | cut -d" " -f2`

#  for controller node, need to add interface to the bridge created by devstack  
shopt -s nocasematch
if [ $node_type == "controller" ]
then
	echo -e "adding interface to bridge \n"

	bridge=`grep OVS_PHYSICAL_BRIDGE "local.conf" | cut -d= -f2`
	port=`echo $bridge | cut -d- -f2`
	sleep 1

	sudo ovs-vsctl add-port $bridge $port
	sleep 1

	sudo ovs-vsctl list-ports $bridge
	echo -e "done ovs adding port to bridge \n"
fi
shopt -u nocasematch

echo -e "congratulations - openstack node installation completed \n"
exit 1

